import { createVuetify } from 'vuetify';
import '@mdi/font/css/materialdesignicons.css';
import 'vuetify/styles';

const myAllBlackTheme: ThemeDefinition = {
    dark: false,
    colors: {
      background: '#000000',
      surface: '#000000',
      primary: '#000000',
      'primary-darken-1': '#000000',
      secondary: '#000000',
      'secondary-darken-1': '#000000',
      error: '#B00020',
      info: '#2196F3',
      success: '#4CAF50',
      warning: '#FB8C00',
    }
  }
  
export default defineNuxtPlugin(nuxtApp => {
    const vuetify = createVuetify({
        // your config will come here
        theme: {
            defaultTheme: 'light',
            // themes: {
            // myAllBlackTheme,
            // }
            themes: {
              light: {
                background: '#FFFFFF',
                surface: '#F2F5F8',
                primary: '#6200EE',
                secondary: '#03DAC6',
                error: '#B00020',
                info: '#2196F3',
                success: '#4CAF50',
                warning: '#FB8C00',
              },
              dark: myAllBlackTheme,
            },
          }
    })

    nuxtApp.vueApp.use(vuetify)
})