import { defineStore } from 'pinia';

interface UserPayloadInterface {
  username: string;
  password: string;
}

export const useProjectStore = defineStore('ProjectStore', {
  state: () => ({
    projects: [],
    errors: null,
    loading: false,
    address: 'http://94.228.121.18/api/projects',
  }),
  actions: {
    async loadData() {
      // 'http://127.0.0.1:8001'
      
      // const url = this.$config.REST_SERVER + '/projects';
      // const token = useCookie('token');
      console.log(this.address, 'url loadData');
      
      try {
        const data = await fetch(this.address,{
          method: 'get',
          headers: { 'Authorization': `Bearer eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpc3MiOiJjb20ub2xpbXAuZXBwbXMiLCJpYXQiOjE2OTg5NTUxOTksImV4cCI6NzY5ODk1NTE5OSwic2NvcGUiOiJhY2Nlc3MiLCJzdWIiOiI0In0.gxUvqJHywewKdjtvZN2betGvU7xFCe6CDPzA2dYpWR0` },
        });
        
        
        if (data?.data) this.projects = data.data;
        console.log(this.projects, 'in store.projects');
        // const json = data.json();
        // if (Array.isArray(data)) {
        //   data.forEach(function(a: Object) {
        //     const date = new Date(a?.last_changed)
        //     const year = date.getFullYear();
        //     let month = date.getMonth() + 1;
        //     let dt = date.getDate();
        //     if (dt < 10) {
        //       dt = "0" + dt;
        //     }
        //     if (month < 10) {
        //       month = "0" + month;
        //     }
        //     a.last_changed = dt + '.' + month + ' ' + year
        //   });
        //   this.projects = data;
        // } 
      } catch(e) {
        console.error('Во время запроса loadData возникли следующие ошибки:\n' + e);
        // this.errors = e;
      }
    },
    async fetchEditPr(project: Object) {
      //  http://127.0.0.1:8001
      const url = this.address+ '/' + project?.id_project;
      try {
        const data = await fetch(url, {
          method: 'put',
          // headers: { 'Authorization': `Bearer eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpc3MiOiJjb20ub2xpbXAuZXBwbXMiLCJpYXQiOjE2OTg5NTUxOTksImV4cCI6NzY5ODk1NTE5OSwic2NvcGUiOiJhY2Nlc3MiLCJzdWIiOiI0In0.gxUvqJHywewKdjtvZN2betGvU7xFCe6CDPzA2dYpWR0` },
          body: JSON.stringify(project),
        });
        
        
        let obj = Object.assign({}, project);
        
        if (data?.data?.id_project) {
          // obj.id_project = data.id_project;
          const json = data.json();

          console.log(obj);
          if (Array.isArray(this.projects)) {
            let match = this.projects.findIndex(pr => pr.id_project == data.data.id_project);
            if (match>=0) this.projects.splice(match, 1, data.data);
          }
          return json;
        }
      }
      catch(e) {
        console.error('Во время запроса возникли следующие ошибки:\n' + e);
        // this.errors = e;
        return [];
      }
    },
    // async unFaveProject(project: Object) {
      
    //   project.is_favorites = false;
    //   let res = await this.fetchEditPr(project);
    //   return res;
    // },
    // async faveProject(project: Object) {
    //   project.is_favorites = true;
    //   let res = await this.fetchEditPr(project);
    //   return res;
    // },
    // async deleteProject({ commit }, project) {
  
    //   if (!project.id_project) return false;
    //   const url = this.$config.REST_SERVER + '/projects/' + project.id_project
    //   try {
    //     const response = await fetch(url, {
    //       method: 'DELETE',
    //       headers: {
    //         'Content-Type': 'application/json; charset=UTF-8'
    //       },
    //     })
    //     const json = await response.json();
    //     console.log("json:", json)
        
    //     if (json.data) {
    //       commit("DELETE_PROJECT", project);
    //       return true;
    //     }
    //     return false;
    //   }
    //   catch(e) {
    //     console.error('Во время запроса' + url + 'возникли следующие ошибки:\n' + e);
    //     return false;
    //   }
    // },
    // async stopProject({commit, dispatch}, project) {
    //   await commit("STOP_PROJECT", project);
    //   project.status = 2;
    //   const res = await dispatch('fetchEditPr', project);
    //   return res;
    // },
    // async runProject({commit, dispatch}, project) {
    //   await commit("RUN_PROJECT", project);
    //   project.status = 1;
    //   const res = await dispatch('fetchEditPr', project);
    //   return res;
    // },
  
    // async editRpoject({ commit }, newProject) {
    //   try {
    //     const response = await fetch('http://127.0.0.1:8001/api/projects', {
    //       method: 'PUT',
    //       headers: {
    //         'Content-Type': 'application/json; charset=UTF-8'
    //       },
    //       body: JSON.stringify(newProject),
    //       })
    //     const json = await response.json();
    //     commit("EDIT_PROJECT", newProject);
    //     return json;
    //   }
    //   catch(e) {
    //     console.error('Во время запроса возникли следующие ошибки:\n' + e);
    //     return [];
        
    //   }
    // },
    async addNew(newProject: Object) {
      
      // const url = this.$config.REST_SERVER + '/projects';
      // const token = useCookie('token');
      console.log(3, newProject, 'url & add NewPR');
      try {
        const data = await fetch(this.address,{
          method: 'patch',
          // headers: { 'Authorization': `Bearer eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpc3MiOiJjb20ub2xpbXAuZXBwbXMiLCJpYXQiOjE2OTg5NTUxOTksImV4cCI6NzY5ODk1NTE5OSwic2NvcGUiOiJhY2Nlc3MiLCJzdWIiOiI0In0.gxUvqJHywewKdjtvZN2betGvU7xFCe6CDPzA2dYpWR0` },
          body: JSON.stringify(newProject),
        });
        let obj = Object.assign({}, newProject);
        
        if (data?.data?.id_project) {
          obj.id_project = data.data.id_project;
          console.log(obj);
          if (Array.isArray(this.projects)) this.projects.push(obj);
        }
        
        console.log(data?.data, this.projects, 'add new to store.projects');
        return data;
      // try {
      //   const response = await fetch(url, {
      //     method: 'POST',
      //     headers: {
      //       'Content-Type': 'application/json; charset=UTF-8'
      //     },
      //     body: JSON.stringify(newProject),
      //     })
      //   const json = await response.json();
  
      //   if (json.data.id_project) {
      //     newProject["id_project"] = json.data.id_project;
      //     console.log(newProject)
  
      //   }
      //   commit("ADD_PROJECT", newProject);
      //   return json.data;
      } catch(e) {
        console.error('Во время запроса возникли следующие ошибки:\n' + e);
        return [];
  
      }
    },
  },
  getters: {
    getProjects: state => state.projects || [],
    getFavProjects: state => {
      if (Array.isArray(state.projects)) state.projects.filter(a => a?.is_favorites)
      else return [];
    },
    authorProjects: state => {
      if (Array.isArray(state.projects)) state.projects.filter(a => a?.owner)
      else return [];
    },
    participantProjects: state => {
      if (Array.isArray(state.projects)) state.projects.filter(a => !a?.owner)
      else return [];
    },
    finishedProjects: state => {
      if (Array.isArray(state.projects)) state.projects.filter(a => a?.status === 3)
      else return [];
    },
    stoppedProjects: state => {
      if (Array.isArray(state.projects)) state.projects.filter(a => a?.status === 2)
      else return [];
    },
    runningProjects: state => {
      if (Array.isArray(state.projects)) state.projects.filter(a => a?.status === 1)
      else return [];
    }
  }
});
